/*
 * (c) 2003, Victoria Staubly (vicky@steeds.com), GPL
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "proto.h"

char *extractCgiParm(char *parm, char *queryString)
{
    int len = 0;
    char tmp;
    char *parmNameBuf = NULL;
    char *namePtr;
    char *valueStart;
    char *valuePtr;
    char *value; /* newly allocated parameter value */

    if (parm == NULL)
	return NULL;
    parmNameBuf = malloc(strlen(parm) + 3); /* 1 for "&", 1 for "=", 1 for null-byte */
    if (parmNameBuf == NULL)
	return NULL; /* failure! out of memory */
    sprintf(parmNameBuf,"%s=",parm);
    if (strncmp(queryString,parmNameBuf,strlen(parmNameBuf)) == 0) {
	/* is the first parameter */
	valueStart = queryString + strlen(parmNameBuf);
    } else {
	sprintf(parmNameBuf,"&%s=",parm);
	namePtr = strstr(queryString,parmNameBuf);
	if (namePtr == NULL)
	    return NULL; /* not found */
	valueStart = namePtr + strlen(parmNameBuf);
    }
    for (valuePtr = valueStart; *valuePtr; valuePtr++)
	if (*valuePtr == '&')
	    break;
    tmp = *valuePtr;
    *valuePtr = '\0';
    value = strdup(valueStart);
    *valuePtr = tmp;

    urlDecode(value); /* converts value in place. */

    return value;
}

void cgiFree(char *value)
{
    if (value != NULL)
	free(value);
}

void urlDecode(char *value)
{
    char hexNum[3]; /* won't allow more than 2 digit numbers... */
    char *src = value;
    char *dst = value;

    for (; *src; src++, dst++) {
	if (*src == '+') {
	    *dst = ' ';
	} else if (*src == '%') {
	    hexNum[0] = src[1];
	    hexNum[1] = src[2];
	    hexNum[2] = '\0';
	    *((unsigned char *)dst) = strtol(hexNum,NULL,16);
	    src += 2;
	} else
	    *dst = *src;
    }
    *dst = '\0'; /* in case string in shortened */
}
